#ifndef lint
static char yysccsid[] = "@(#)yaccpar    1.4 (Berkeley) 02/25/90";
#endif
#line 2 "xmatch.y"
/*	This is a yacc program for xmatch processor.*/
/*      copyright (C) 2001 Makoto Onizuka, University of Washington*/
/*      $Id: xmatch.y,v 1.11 2002/11/28 08:30:57 onizuka Exp $*/
/* Restriction: */
/*  1. It is not implemented to use attribute type name as an attribute name.*/
/*     (CDATA, ID, IDREF, and so forth)*/
/*  2. It is not implemented to use entity declaration, notation declaration,*/
/*     and PI (processing instruction).        */
/*  3. Comment declaration is implemented using lex.*/

#include <stdio.h>
#include "Root.h"
#include "Query.h"
#ifdef WIN32
#include "xmatch.h"
#endif
extern int lineno;		/* for lex error.*/
extern char * yytext;		/* for lex error.*/
#ifndef WIN32
#if defined(__cplusplus)
extern "C" {
#endif    
#endif
extern int DFAlex(void);

#ifdef WIN32
#include <malloc.h>
#define alloca _alloca
#endif

char *yytext = NULL;
int lineno = 0;

int yyerror(char * mes){
  fprintf(stderr, "yacc(lazyDFA) error (line %d): %s at \"%s\" in \"%s\"\n",
          lineno, mes, yytext, __gQuery->query);
  return 0;
}

int my_DFAinput(char * buf, int max_size){
    int n;

    n = min(max_size, strlen(__gQuery->top));

    if (n > 0){
        memcpy(buf, __gQuery->top, n);
	__gQuery->top += n;
    }
    return n;
}

#ifndef WIN32
#if defined(__cplusplus)
};
#endif
#endif

static Variable * var;		/* Variable Definition*/
static XPath * xpath, * pxpath;	/* XPath expression*/
				/* LocationStep*/
static LocationStep  * lstep, * plstep;
static Predicate     * pred;
static AtomPredicate * ap;
static Expression    * expr;	/* Predicate's right or left side expression*/
static Root	     * gRoot;
#line 68 "xmatch.y"
typedef union {
  char* strval;			/* for many purpose to store string */
  float fltval;			/* for float literal value */
  int   intval;			/* for integer literal value */
  int   subtok;			/* for basic operator type */
} YYSTYPE;
#line 77 "y.tab.c"
#define ENAME 257
#define ANAME 258
#define EREF 259
#define AREF 260
#define FCALL 261
#define STRING 262
#define INTEGER 263
#define FLOAT 264
#define OR 265
#define AND 266
#define OPERATOR 267
#define FUNCTION 268
#define DIV 269
#define MOD 270
#define UMINUS 271
#define MAP 272
#define VARDEF 273
#define IN 274
#define ARROW 275
#define SLASH 276
#define DSLASH 277
#define TEXT 278
#define YYERRCODE 256
int yylhs[] = {                                        -1,
    2,    0,    0,    1,    1,    1,    3,    3,    6,    6,
    4,    4,    9,    5,   10,    5,   11,    5,   12,    5,
   13,    5,   14,    5,   15,    5,   17,    5,   18,    7,
   19,    7,   20,    7,   21,    7,   22,    7,   23,    7,
   24,    7,   16,   25,   16,    8,    8,   28,   26,   29,
   26,   31,   27,   27,   27,   27,   30,   30,   33,   34,
   30,   35,   30,   32,   32,   36,   36,   36,
};
int yylen[] = {                                         2,
    0,    2,    1,    1,    1,    2,    1,    3,    1,    3,
    1,    1,    0,    3,    0,    4,    0,    3,    0,    4,
    0,    3,    0,    3,    0,    4,    0,    4,    0,    3,
    0,    4,    0,    3,    0,    4,    0,    3,    0,    3,
    0,    4,    1,    0,    4,    0,    1,    0,    4,    0,
    5,    0,    2,    3,    3,    3,    1,    1,    0,    0,
    7,    0,    4,    1,    1,    1,    1,    1,
};
int yydefred[] = {                                      0,
    3,    0,    0,   21,   23,    0,   12,    0,    0,   17,
    0,   27,    2,    0,    0,    7,    0,    0,   25,   15,
    0,    0,   19,    0,   11,    0,    0,   48,   22,    0,
   24,    0,    0,   14,   18,    0,    0,    0,    8,    0,
   50,   26,   16,   20,   28,   44,    0,    0,    0,    0,
    0,    0,    0,    0,   49,   37,   39,   66,    0,   68,
    0,    0,    0,   33,    0,    0,    9,   53,   62,   65,
    0,    0,   56,    0,   54,    0,    0,   67,    0,   59,
   41,   31,    0,    0,   35,    0,    0,   51,   38,   40,
    0,    0,    0,   30,   34,    0,   10,    0,    0,   42,
   32,   36,   63,   60,    0,   61,
};
int yydgoto[] = {                                       2,
   13,    3,   14,   26,   16,   79,   67,   29,   21,   33,
   22,   36,   17,   18,   32,   38,   24,   83,   93,   84,
   96,   76,   77,   92,   51,   30,   48,   40,   50,   68,
   49,   69,   91,  105,   87,   70,
};
int yysindex[] = {                                   -242,
    0,    0,  -40,    0,    0,    0,    0,  -16,  -20,    0,
   -6,    0,    0, -254,  -29,    0,  -54,  -54,    0,    0,
  -54,  -54,    0,  -29,    0,  -29, -254,    0,    0,  -52,
    0,  -54,  -54,    0,    0,  -54, -254,  -26,    0,    2,
    0,    0,    0,    0,    0,    0,    2,  -86,  -12,    2,
  -29,   -3,    2,    2,    0,    0,    0,    0,    0,    0,
   31,   -1,   -2,    0,   13, -254,    0,    0,    0,    0,
  -81, -254,    0, -220,    0,  -54,  -54,    0, -254,    0,
    0,    0,  -54,  -54,    0,  -14, -209,    0,    0,    0,
   15,  -54,  -54,    0,    0,  -54,    0,   31,   31,    0,
    0,    0,    0,    0,   20,    0,
};
int yyrindex[] = {                                    -37,
    0,    0,    0,    0,    0,    1,    0,    0,    8,    0,
    0,    0,    0,   62,    0,    0,   10,   10,    0,    0,
   10,   10,    0,    0,    0,    0,   63,    0,    0,    4,
    0,   10,   10,    0,    0,   10,  -22,    0,    0,   14,
    0,    0,    0,    0,    0,    0,   14,    0,    0,   14,
    0,    0,   14,   14,    0,    0,    0,    0,   -8,    0,
    0,    0,  -23,    0,    0,   33,    0,    0,    0,    0,
    0,  -21,    0,  -10,    0,   38,   38,    0,   23,    0,
    0,    0,   38,   38,    0,    0,    0,    0,    0,    0,
    0,   38,   38,    0,    0,   38,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
int yygindex[] = {                                      0,
    0,    0,   42,   26,   45,   32,    5,   68,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   22,    0,    0,    0,
    0,  -45,    0,    0,    0,    0,
};
#define YYTABLESIZE 315
int yytable[] = {                                      12,
    5,   10,    1,   47,    1,    9,   55,   13,    1,   46,
   12,   88,   10,    1,   45,   80,    9,   29,   43,   45,
   29,   25,    7,   11,   19,   20,    1,   64,   15,   64,
   55,   63,   58,   63,   11,   23,   28,   73,   41,   81,
   11,   47,   11,   82,   47,   54,   11,   47,   13,   65,
   46,   65,  103,  104,   85,   52,   27,   98,   99,   52,
  106,    4,    6,   64,   11,   37,   64,   29,   52,   29,
   39,   71,   64,   57,   74,   75,   63,   52,   46,    0,
   66,   46,   55,    0,   58,   31,    0,    0,   34,   35,
   97,   86,   72,    0,   65,    0,   47,   46,   13,   42,
   43,   43,   45,   44,   86,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   64,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   57,    0,   47,    0,    0,
   46,   13,    0,   46,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   89,   90,    0,    0,    0,    0,    0,
   94,   95,    0,    0,    0,    0,    0,    0,    0,  100,
  101,    0,    0,  102,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   53,   54,
    0,    0,    0,   53,   54,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    4,    5,
    0,    1,    1,    0,    0,    0,    0,    0,    0,    4,
    5,    0,    0,    0,    0,    6,    7,    8,    1,    1,
    1,   29,   29,   29,   56,   57,   56,   57,    8,   58,
   59,   60,   29,   29,   55,   61,   58,   58,   67,   11,
   11,   53,   54,   62,    0,   62,    0,    0,   47,   47,
   47,    0,   52,   52,    0,   52,   52,   52,   11,   47,
   47,   52,    0,   13,   13,   46,   46,   64,   64,   56,
   57,   52,   58,   78,   60,    0,    0,   57,   57,   64,
    0,    0,   46,   46,   46,    0,    0,    0,   62,    0,
    0,    0,    0,   46,   46,
};
int yycheck[] = {                                      40,
    0,   42,   40,    0,   42,   46,   93,    0,   46,    0,
   40,   93,   42,  256,   41,   61,   46,   41,   41,   41,
   44,  276,  277,   64,   41,   46,   64,   42,    3,   42,
   41,   46,   41,   46,   64,   42,   91,   41,   91,   41,
   40,   40,   42,   46,   41,  266,   46,   44,   41,   64,
   41,   64,   98,   99,   42,   42,   15,  267,   44,   46,
   41,    0,    0,   41,   64,   24,   44,   91,   47,   93,
   26,   50,   42,   41,   53,   54,   46,   64,   41,   -1,
   49,   44,   93,   -1,   93,   18,   -1,   -1,   21,   22,
   86,   66,   51,   -1,   64,   -1,   93,  124,   91,   32,
   33,  124,  124,   36,   79,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   -1,  124,   -1,   -1,
   93,  124,   -1,  124,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   76,   77,   -1,   -1,   -1,   -1,   -1,
   83,   84,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   92,
   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,
   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  259,  260,
   -1,  259,  260,   -1,   -1,   -1,   -1,   -1,   -1,  259,
  260,   -1,   -1,   -1,   -1,  276,  277,  278,  276,  277,
  278,  265,  266,  267,  259,  260,  259,  260,  278,  262,
  263,  264,  276,  277,  265,  268,  265,  266,  267,  259,
  260,  265,  266,  278,   -1,  278,   -1,   -1,  265,  266,
  267,   -1,  259,  260,   -1,  262,  263,  264,  278,  276,
  277,  268,   -1,  276,  277,  276,  277,  265,  266,  259,
  260,  278,  262,  263,  264,   -1,   -1,  265,  266,  267,
   -1,   -1,  265,  266,  267,   -1,   -1,   -1,  278,   -1,
   -1,   -1,   -1,  276,  277,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 278
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'",0,"','",0,"'.'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'@'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'",0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'|'",0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"ENAME","ANAME","EREF","AREF","FCALL","STRING","INTEGER","FLOAT","OR","AND",
"OPERATOR","FUNCTION","DIV","MOD","UMINUS","MAP","VARDEF","IN","ARROW","SLASH",
"DSLASH","TEXT",
};
char *yyrule[] = {
"$accept : varExpr",
"$$1 :",
"varExpr : $$1 locationPath",
"varExpr : error",
"locationPath : relativeLocationPath",
"locationPath : SLASH",
"locationPath : pathConnect relativeLocationPath",
"relativeLocationPath : lStepExpr",
"relativeLocationPath : relativeLocationPath pathConnect lStepExpr",
"relativeLocationPathNoAlt : lStepExprNoAlt",
"relativeLocationPathNoAlt : relativeLocationPathNoAlt pathConnect lStepExprNoAlt",
"pathConnect : SLASH",
"pathConnect : DSLASH",
"$$2 :",
"lStepExpr : '.' $$2 optPredicateListExpr",
"$$3 :",
"lStepExpr : '.' '.' $$3 optPredicateListExpr",
"$$4 :",
"lStepExpr : '*' $$4 optPredicateListExpr",
"$$5 :",
"lStepExpr : '@' '*' $$5 optPredicateListExpr",
"$$6 :",
"lStepExpr : EREF $$6 optPredicateListExpr",
"$$7 :",
"lStepExpr : AREF $$7 optPredicateListExpr",
"$$8 :",
"lStepExpr : TEXT ')' $$8 optPredicateListExpr",
"$$9 :",
"lStepExpr : '(' $$9 altPathListExpr ')'",
"$$10 :",
"lStepExprNoAlt : '.' $$10 optPredicateListExpr",
"$$11 :",
"lStepExprNoAlt : '.' '.' $$11 optPredicateListExpr",
"$$12 :",
"lStepExprNoAlt : '*' $$12 optPredicateListExpr",
"$$13 :",
"lStepExprNoAlt : '@' '*' $$13 optPredicateListExpr",
"$$14 :",
"lStepExprNoAlt : EREF $$14 optPredicateListExpr",
"$$15 :",
"lStepExprNoAlt : AREF $$15 optPredicateListExpr",
"$$16 :",
"lStepExprNoAlt : TEXT ')' $$16 optPredicateListExpr",
"altPathListExpr : relativeLocationPath",
"$$17 :",
"altPathListExpr : altPathListExpr '|' $$17 relativeLocationPath",
"optPredicateListExpr :",
"optPredicateListExpr : predicateListExpr",
"$$18 :",
"predicateListExpr : '[' $$18 predicateExpr ']'",
"$$19 :",
"predicateListExpr : predicateListExpr '[' $$19 predicateExpr ']'",
"$$20 :",
"predicateExpr : $$20 atomPredExpr",
"predicateExpr : predicateExpr AND predicateExpr",
"predicateExpr : predicateExpr OR predicateExpr",
"predicateExpr : '(' predicateExpr ')'",
"atomPredExpr : relativeLocationPathNoAlt",
"atomPredExpr : INTEGER",
"$$21 :",
"$$22 :",
"atomPredExpr : FUNCTION expr $$21 ',' expr $$22 ')'",
"$$23 :",
"atomPredExpr : expr $$23 OPERATOR expr",
"expr : relativeLocationPathNoAlt",
"expr : literalExpr",
"literalExpr : STRING",
"literalExpr : INTEGER",
"literalExpr : FLOAT",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifndef YYSTACKSIZE
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
int *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
#define yystacksize YYSTACKSIZE
int yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 97 "xmatch.y"
{ gRoot = __gQuery->getRoot();
	      var = new Variable();
	      gRoot->insertVariable(var);
	      xpath = new XPath();
	    }
break;
case 2:
#line 101 "xmatch.y"
{
	      var->setXPath(xpath);
	    }
break;
case 3:
#line 104 "xmatch.y"
{ return -1;}
break;
case 4:
#line 108 "xmatch.y"
{
        plstep = xpath->getLastLStep();
		/* in case expression like "/bib/book/" */
        if (plstep!=0 && plstep->getType()==LocationStep::DoubleSlash)
        {
            throw CXmlToolkitException("A tag must be specified just after //.");
        }
}
break;
case 6:
#line 117 "xmatch.y"
{
	      plstep = xpath->getLastLStep();
				/* in case expression like "/bib/book/" */
	      if (plstep!=0 && plstep->getType()==LocationStep::DoubleSlash){
		throw CXmlToolkitException("A tag must be specified just after //.");
	      }
            }
break;
case 12:
#line 139 "xmatch.y"
{
    lstep = new LocationStep(xpath, LocationStep::DoubleSlash, 0);
}
break;
case 13:
#line 151 "xmatch.y"
{		/* period*/
    lstep = new LocationStep(xpath, LocationStep::Period, 0);
}
break;
case 15:
#line 161 "xmatch.y"
{		/* period period */
    throw CXmlToolkitException("'..' is not supported.");
}
break;
case 17:
#line 173 "xmatch.y"
{		/* element simple path */
    lstep = new LocationStep(xpath, LocationStep::AnyElement, 0);
}
break;
case 19:
#line 183 "xmatch.y"
{		/* element simple path */
    lstep = new LocationStep(xpath, LocationStep::AnyAttribute, 0);
}
break;
case 21:
#line 193 "xmatch.y"
{		/* element simple path */
    lstep = new LocationStep(xpath, LocationStep::Element, yyvsp[0].strval );
}
break;
case 23:
#line 203 "xmatch.y"
{		/* attribute simple path */
    lstep = new LocationStep(xpath, LocationStep::Attribute, yyvsp[0].strval );
}
break;
case 25:
#line 213 "xmatch.y"
{		/* text() */
    lstep = new LocationStep(xpath, LocationStep::Text, 0);
}
break;
case 27:
#line 223 "xmatch.y"
{		/* nested alternation (choice) */
    lstep = new LocationStep(xpath, LocationStep::AltElement, 0);
    pxpath = xpath;
    xpath = new XPath();          /* for alternative path */
    lstep->insertAltPath(xpath);
}
break;
case 28:
#line 235 "xmatch.y"
{
    xpath  = pxpath;
    pxpath = xpath->getParent();
}
break;
case 29:
#line 248 "xmatch.y"
{		/* period*/
    lstep = new LocationStep(xpath, LocationStep::Period, 0);
}
break;
case 31:
#line 258 "xmatch.y"
{		/* period period */
    throw CXmlToolkitException("'..' is not supported.");
}
break;
case 33:
#line 270 "xmatch.y"
{		/* element simple path */
    lstep = new LocationStep(xpath, LocationStep::AnyElement, 0);
}
break;
case 35:
#line 280 "xmatch.y"
{		/* element simple path */
    lstep = new LocationStep(xpath, LocationStep::AnyAttribute, 0);
}
break;
case 37:
#line 290 "xmatch.y"
{		/* element simple path */
    lstep = new LocationStep(xpath, LocationStep::Element, yyvsp[0].strval );
}
break;
case 39:
#line 300 "xmatch.y"
{		/* attribute simple path */
    lstep = new LocationStep(xpath, LocationStep::Attribute, yyvsp[0].strval );
}
break;
case 41:
#line 310 "xmatch.y"
{		/* text() */
    lstep = new LocationStep(xpath, LocationStep::Text, 0);
}
break;
case 44:
#line 324 "xmatch.y"
{/* pxpath dose not needed to change here */
    xpath = new XPath();
	plstep = pxpath->getLastLStep();
	plstep->insertAltPath(xpath);
}
break;
case 47:
#line 339 "xmatch.y"
{
    lstep->setType();
}
break;
case 48:
#line 345 "xmatch.y"
{
	         pxpath = xpath;
		 xpath = new XPath();
		 xpath->setParent(pxpath);
		 pred = new Predicate(var,0);
		 lstep->addPredicate(pred);
	       }
break;
case 49:
#line 352 "xmatch.y"
{
		 xpath  = pxpath;
		 pxpath = xpath->getParent();
		 lstep  = xpath->getLastLStep();
	       }
break;
case 50:
#line 357 "xmatch.y"
{
		 pxpath = xpath;
		 xpath = new XPath();
		 xpath->setParent(pxpath);
		 pred = new Predicate(var,0);
		 lstep->addPredicate(pred);
	       }
break;
case 51:
#line 364 "xmatch.y"
{
	         xpath  = pxpath;
		 pxpath = xpath->getParent();
		 lstep  = xpath->getLastLStep();
	       }
break;
case 52:
#line 372 "xmatch.y"
{
	    pred->atom = new AtomPredicate();
	  }
break;
case 53:
#line 374 "xmatch.y"
{
	    pred->setType();	/* after the ap->oprType set */
	  }
break;
case 54:
#line 377 "xmatch.y"
{
    throw CXmlToolkitException("AND operator isn't supported yet. Please modify it to [cond1][cond2].");
}
break;
case 55:
#line 381 "xmatch.y"
{
    throw CXmlToolkitException("OR operator isn't supported yet.");
}
break;
case 57:
#line 389 "xmatch.y"
{	/* unary: existence check */
	    plstep = pxpath->getLastLStep();
	    pred = plstep->getLastPred();
	    ap = pred->getTopAtom();
	    ap->oprType = AtomPredicate::T_UNARY;
	    ap->left = new Expression(xpath);
	  }
break;
case 58:
#line 396 "xmatch.y"
{			/* index number */
    if (yyvsp[0].intval  == 0)
    {
        // yyvsp[0].intval
        throw CXmlToolkitException("Index number needs to be larger than 1.");
    }
    
    plstep = pxpath->getLastLStep();
    pred = plstep->getLastPred();
    ap = pred->getTopAtom();
    ap->oprType = AtomPredicate::T_INDEX;
    ap->left = new Expression(yyvsp[0].intval );
}
break;
case 59:
#line 407 "xmatch.y"
{ 		/* function */
    plstep = pxpath->getLastLStep();
    pred = plstep->getLastPred();
    ap = pred->getTopAtom();
    ap->opr = yyvsp[-1].subtok ;
    ap->oprType = AtomPredicate::T_FUNCTION;
    ap->left = expr;
    if (!expr->getXPath())
    {
        throw CXmlToolkitException("Conditions need to be in the form [function(xpath,literal)].");
    }
}
break;
case 60:
#line 418 "xmatch.y"
{
    plstep = pxpath->getLastLStep();
    pred = plstep->getLastPred();
    ap = pred->getTopAtom();
    ap->right = expr;
    if (expr->getXPath())
    {
	    throw CXmlToolkitException("Conditions need to be in the form [function(xpath,literal)].");
    }
}
break;
case 62:
#line 428 "xmatch.y"
{			/* binary: condition */
    plstep = pxpath->getLastLStep();
    pred = plstep->getLastPred();
    ap = pred->getTopAtom();
    ap->oprType = AtomPredicate::T_BINARY;
    ap->left = expr;
    if (!expr->getXPath())
    {
        throw CXmlToolkitException("Conditions need to be in the form [function(xpath,literal)].");
    }
}
break;
case 63:
#line 439 "xmatch.y"
{
    plstep = pxpath->getLastLStep();
    pred = plstep->getLastPred();
    ap = pred->getTopAtom();
    ap->opr = yyvsp[-1].subtok ;
    ap->right = expr;
    if (expr->getXPath())
    {
        throw CXmlToolkitException("Conditions need to be in the form [function(xpath,literal)].");
    }
}
break;
case 64:
#line 453 "xmatch.y"
{ /* path expression */
	    expr = new Expression(xpath);
	  }
break;
case 66:
#line 460 "xmatch.y"
{
			 expr = new Expression(strdup(yyvsp[0].strval ));
		   }
break;
case 67:
#line 463 "xmatch.y"
{
			 expr = new Expression(yyvsp[0].intval );
	       }
break;
case 68:
#line 466 "xmatch.y"
{
			 expr = new Expression(yyvsp[0].fltval );
	       }
break;
#line 926 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
